Subject: Additional comments on draft-duerst-mailto-bis-07.txt

From: Alexey Melnikov <[email-masked]>
Date: Sat, 28 Nov 2009 14:55:13 +0000

Hi Martin/Larry,
I've requested IETF LC for this document. The following extra comments can be considered as a part of IETF LC.

>2.  Syntax of a 'mailto' URI
>
>   The syntax of a 'mailto' URI is described using the ABNF of [STD68],
>   non-terminal definitions from [RFC5322] (dot-atom, quoted-string) and
>   non-terminal definitions from [STD66] (unreserved, pct-encoded):
>
>      mailtoURI   = "mailto:" [ to ] [ hfields ]
>      to          = [ addr-spec *("%2C" addr-spec ) ]
>      hfields     = "?" hfield *( "&" hfield )
>      hfield      = hfname "=" hfvalue
>      hfname      = *qchar
>      hfvalue     = *qchar
>      addr-spec   = local-part "@" domain
>      local-part  = dot-atom / quoted-string
>      domain      = dot-atom

I think you should be using "dot-atom-text" instead:

   atext           =   ALPHA / DIGIT /    ; Printable US-ASCII
                       "!" / "#" /        ;  characters not including
                       "$" / "%" /        ;  specials.  Used for atoms.
                       "&" / "'" /
                       "*" / "+" /
                       "-" / "/" /
                       "=" / "?" /
                       "^" / "_" /
                       "`" / "{" /
                       "|" / "}" /
                       "~"

   atom            =   [CFWS] 1*atext [CFWS]

   dot-atom-text   =   1*atext *("." 1*atext)

   dot-atom        =   [CFWS] dot-atom-text [CFWS]

I.e. I don't think we want CFWS.

>      qchar       = unreserved / pct-encoded / some-delims
>      some-delims = "!" / "$" / "'" / "(" / ")" / "*"
>                  / "+" / "," / ";" / ":" / "@"

[...]

>   Implementations SHOULD NOT produce two "To:" header fields in a
>   message; the "To:" header field may occur at most once in a message
>   ([RFC5322], Section 3.6).  Also, creators of 'mailto' URIs SHOULD NOT
>   include other message header fields multiple times if these header
>   fields can only be used once in a message.
>  
>
Any reasons why these SHOULD NOTs are not MUST NOTs?

>From ID-nits:
>
>Miscellaneous warnings:
>  ----------------------------------------------------------------------------
>
>  == The document seems to lack the recommended RFC 2119 boilerplate, even if
>     it appears to use RFC 2119 keywords -- however, there's a paragraph with
>     a matching beginning. Boilerplate error?
>
>     (The document does seem to have the reference to RFC 2119 which the
>
>     ID-Checklist requires).
>  
>
I think this can be fixed by the RFC Editor, but if you have to do a new 
revision, you might as well fix that.

---

From: "Martin J. Dürst" <[email-masked]>
Date: Mon, 30 Nov 2009 16:21:52 +0900

Hello Alex,

On 2009/11/28 23:55, Alexey Melnikov wrote:
> Hi Martin/Larry,
> I've requested IETF LC for this document.

Thanks. For a while, I wasn't sure how you wanted to proceed, this makes 
is clear.

> The following extra comments
> can be considered as a part of IETF LC.

Okay.

> I think you should be using "dot-atom-text" instead:

Instead of what? Instead of "dot-atom" (as used above in "local-part" 
and "domain")? [I think that's what you mean, and it would make sense, 
but please confirm.]

> "$" / "%" / ; specials. Used for atoms.

Looking at this list actually makes me worry that it's way too open; 
definitely "%" and "?", and maybe some others, cannot appear directly in 
that part of a mailto URI (they certainly can appear %-escaped). I'll 
have to check the text to make sure everything here is correct.

> Any reasons why these SHOULD NOTs are not MUST NOTs?

Not being a mail expert, I have no experience on what goes wrong if 
these restrictions are not met. If you think a MUST is more appropriate, 
that's fine with me. But I didn't find a MUST in RFC 5322, it just says:

The following table indicates limits on the number of times each
field *may* occur in the header section of a message...
(emphasis mine).

> revision, you might as well fix that.

I will try.

Regards,    Martin.

-- 
#-# Martin J. Dürst, Professor, Aoyama Gakuin University
#-# http://www.sw.it.aoyama.ac.jp   mailto:[email-masked]

---

From: Alexey Melnikov <[email-masked]>
Date: Mon, 30 Nov 2009 11:40:50 +0000

Martin J. Dürst wrote:

> Thanks. For a while, I wasn't sure how you wanted to proceed, this 
> makes is clear.

My opinion has changed slightly after I posted my message to the EAI 
mailing list.

> and "domain")? [I think that's what you mean, and it would make sense, 

Yes.

> definitely "%" and "?", and maybe some others, cannot appear directly 
> in that part of a mailto URI (they certainly can appear %-escaped). 
> I'll have to check the text to make sure everything here is correct.

Making the syntax more restrictive would be better, of course. 
Referencing URI production for the hostname (reg-name?) might be Ok as well.